
--[[
Title: State machine example
Author: Carl Reed
Date: 7-25-2013
Purpose: Example of State machine functions and State Classes using Middleclass, for Shanulu
License: MIT-LICENSE -
Copyright (c) 2013 Carl Reed

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
]]

require "middleclass"
require "states"

function love.load()
	states = {}
	sw = love.graphics.getWidth()
	sh = love.graphics.getHeight()
	title = TitleState()
	pushState(title)
end

function love.update(dt)
	for i,state in ipairs(states) do
		if i==#states then
			state:update(dt)
		else
			if state.alwaysUpdate then state:update(dt) end
		end
	end
end

function love.draw()
	for i,state in ipairs(states) do
		if i==#states then
			state:draw()
		else
			if state.alwaysDraw then state:draw() end
		end
	end
end
